///////////////
// IanniX
///////////////

////////////////////////////
// MAIN FILE
////////////////////////////

#include "../widgets/NxView.h"

// IanniX Main Instance
QApplication* app;
QFileDialog* chooser;
QDialog* opener;
NxView* partitionViewer;
QRadioButton *newBtn, *fileBtn ;
bool canc ;

char* ext = NULL;
char* str = NULL;
QList<QString> XMLfiles;
int count = 0;

// Methods prototypes
void chooseFile();
bool isValid(QString inString);
void openDialog();


int main( int argc, char **argv )
{	
	// New Application Object
	app = new QApplication ( argc, argv );
	app->setStyle(new QPlastiqueStyle);
	app->setDoubleClickInterval(300) ;
	
	//QIcon appIcon = QIcon(":/pixmaps/IanniX.png") ;
	//app->setWindowIcon(appIcon) ;
		
	//QFont f("Verdana");
	//QApplication::setFont(f) ;
	
  	// Initializing Score Viewer
	partitionViewer = new NxView();	
	
	// Converting to QStringList
	for(int i=0; i<argc;i++) {
		XMLfiles << argv[i];
	}
	
  	// Parsing Commandline
  	switch (argc)
	{	
		case 1 :
			openDialog();
		break;
		default:
			for( int i=0;i<argc;i++) {
	  			if (isValid(XMLfiles.at(i))) {
					partitionViewer->setXMLinput(XMLfiles.at(i)) ;	
	  				partitionViewer->launchGLBox(XMLfiles.at(i), false);
				}
			}
     	break;
	}

  	if(!canc) {
		partitionViewer->show();	
		return app->exec();
	}
	else
		return 0 ;
}

bool isValid(QString inString)
{
	return (inString.endsWith(".xml"));
}

////////////////////////////
// File Chooser
////////////////////////////
void chooseFile()
{
	XMLfiles = chooser->getOpenFileNames(
					0,
					"Select one or more files to open",
					".",
					"XML Files (*.xml)");
		
	for(int i=0; i<XMLfiles.size(); i++) 
	{
		partitionViewer->setXMLinput( XMLfiles.at(i) );	
		partitionViewer->launchGLBox( XMLfiles.at(i), false );
	}
}

///////////////////////////////
// Settings dialog
///////////////////////////////
void openDialog()
{
	opener = new QDialog;
  	opener->setWindowTitle( "IanniX Opener" );
	
  	QGroupBox* mainBox 		= new QGroupBox(opener); //ajout du parent
  	newBtn 	= new QRadioButton( "New Document" );		
  	fileBtn = new QRadioButton( "Open XML File" );
  	QPushButton *validBtn 	= new QPushButton( "Open IanniX" );
  	QPushButton *cancelBtn 	= new QPushButton( "Cancel" );
	QVBoxLayout *layout 	= new QVBoxLayout;
	
	layout->addWidget(newBtn);
	layout->addWidget(fileBtn);
	layout->addWidget(validBtn);
	layout->addWidget(cancelBtn); 
	mainBox->setLayout(layout);
	
  	newBtn->setText( "New Score" );
  	newBtn->setChecked( true );
  	fileBtn->setText( "Score(s) from XML file(s)" );
	
  	validBtn->setText( "Start" );
  	cancelBtn->setText( "Cancel" );
  	validBtn->setMaximumSize( 70, 30 );
  	cancelBtn->setMaximumSize( 70, 30 );
	
	// Main Layout
	QVBoxLayout *mainLayout = new QVBoxLayout;
	mainLayout->addWidget(mainBox);
	opener->setLayout(mainLayout);
	
	opener->setFixedSize( 220, 170 ) ;
	
	// Signals & Slots
	QObject::connect(validBtn, 	SIGNAL(clicked()), opener, SLOT(accept()));
	QObject::connect(cancelBtn, SIGNAL(clicked()), opener, SLOT(reject()));
	
  	if ( opener->exec() == QDialog::Accepted ) {
		canc = false ;	
		if ( newBtn->isChecked() )
			partitionViewer->newScore();
		else
		if ( fileBtn->isChecked() )
			chooseFile();
		opener->close() ;
	} else
		canc = true ;
}

